import dataclasses
import typing

from ._base import Artifact
from .addon import Addon
from .issue import Location


@dataclasses.dataclass
class ExternalIDReference(Artifact):
    addon: Addon
    addon_name: typing.Optional[typing.Union[str, object]]
    record_id: str
    model: typing.Union[str, object]
    location: Location


@dataclasses.dataclass
class ExternalID(ExternalIDReference):
    """External ID definition."""

    ...
