import csv

from odd.plugin import Plugin
from odd.artifact import AddonPath, CSVRow


class CSVRowEmitter(Plugin):
    _handles = {"data_file", "demo_file"}
    _emits = {"csv_row"}

    def _load_csv(self, addon_path: AddonPath):
        if addon_path.path.suffix.lower() == ".csv":
            with addon_path.path.open(mode="r") as f:
                for idx, row in enumerate(csv.DictReader(f), start=2):
                    yield CSVRow(addon_path.addon, addon_path.path, row, idx)

    on_data_file = on_demo_file = _load_csv
