from defusedxml import lxml

from odd.artifact import AddonPath, XMLDocument
from odd.plugin import Plugin


class XMLDocumentEmitter(Plugin):
    _handles = {"data_file", "demo_file"}
    _emits = {"xml_document"}

    def _load_tree(self, addon_path):
        if addon_path.path.suffix.lower() == ".xml":
            with addon_path.path.open(mode="rb") as f:
                root_node = lxml.parse(f).getroot()
            yield XMLDocument(addon_path.addon, addon_path.path, root_node)

    def on_data_file(self, addon_path: AddonPath):
        yield from self._load_tree(addon_path)

    def on_demo_file(self, addon_path: AddonPath):
        yield from self._load_tree(addon_path)
